// AppWnd.cpp : implementation file
//

#include "stdafx.h"
#include "sameproc.h"
#include "AppWnd.h"
#include "AppThread.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAppWnd

IMPLEMENT_DYNCREATE(CAppWnd, CFrameWnd)

CAppWnd::CAppWnd()
 :m_bCanClose(false)
{
}

CAppWnd::~CAppWnd()
{
}


BEGIN_MESSAGE_MAP(CAppWnd, CFrameWnd)
	//{{AFX_MSG_MAP(CAppWnd)
	ON_WM_COPYDATA()
	ON_WM_CLOSE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


namespace
{
	static TCHAR szClassName[] = _T("SameProcClass");
}


/////////////////////////////////////////////////////////////////////////////
// CAppWnd message handlers

bool CAppWnd::CreateAppWnd()
{
	//Register SameProcClass
	WNDCLASS wndclass;
	
	::ZeroMemory(&wndclass, sizeof(WNDCLASS));

	wndclass.lpfnWndProc = AfxWndProc;
	wndclass.lpszClassName = szClassName;// "SameProcClass"
	wndclass.hInstance = AfxGetInstanceHandle();

	if (!AfxRegisterClass(&wndclass))
	{
		AfxMessageBox(SP_IDP_REGISTER_FAILED);
		return false;	
	}

	//Now create the window
	if (!CFrameWnd::Create(szClassName, _T("SameProcMainWnd"), 0))
	{
		AfxMessageBox(SP_IDP_CREATEFAILED);
		return false;	
	}

	return true;
}

CAppWnd* CAppWnd::FindAppWnd()
{
	
	//Finds a window of SameProcClass
	if (CWnd* pWnd = CWnd::FindWindow(szClassName, NULL))
	{
		return static_cast<CAppWnd*>(pWnd);
	}

	return NULL;
}


BOOL CAppWnd::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pCopyDataStruct) 
{
	//See that we don't close
	m_bCanClose = false;
	
	//Command line info from another instance is communicated here
	
	//If you are interested in having the command line processing you have to add
	//a bit of code to pass it to CAppThread class
	DWORD nCmdShow = pCopyDataStruct->dwData ;
	LPTSTR szCmdLine = reinterpret_cast<LPTSTR>(pCopyDataStruct->lpData);
	
	AfxBeginThread(RUNTIME_CLASS(CAppThread));

	return CFrameWnd::OnCopyData(pWnd, pCopyDataStruct);
}

void CAppWnd::OnClose() 
{
	static bool bTimerSet = false;
	if (!m_bCanClose)
	{
		if (bTimerSet)
			KillTimer(1);

		m_bCanClose = true;
		//Set a timer after which we can close
		SetTimer(1, 1000, NULL);

		bTimerSet = true;
	}
	else
	{
		KillTimer(1);
		CFrameWnd::OnClose();
	}
}

void CAppWnd::OnTimer(UINT nIDEvent) 
{

	if (nIDEvent == 1)
		PostMessage(WM_CLOSE);
}


